%&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
%Calculating Delta matrix for parameter tau
%&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&

%Case-weight perturbation

for i=1:n 
        Partial1_f=-2*W_g(i,:)*N*inv(sigma_nor)*E(i,:)'; 
        Partial1_tau=-(1/2)*trace(inv(sigma_nor)*Z*dD_tau*Z')-W_g(i,:)*E(i,:)*inv(sigma_nor)*Z*dD_tau*Z'*inv(sigma_nor)*E(i,:)';
        Partial1_fi=-(1/2)*trace(inv(sigma_nor)*dV_fi)-W_g(i,:)*E(i,:)*inv(sigma_nor)*dV_fi*inv(sigma_nor)*E(i,:)';
        Delta1_i=[Partial1_tau;Partial1_f;Partial1_fi];
        DELTA1(:,i)=Delta1_i;
end


%Scale perturbation

for i=1:n
    Partial3_f=-2*(W_g_der(i,:)*E(i,:)*inv(sigma_nor)*E(i,:)' + W_g(i,:))*N'*inv(sigma_nor)*E(i,:)';
    Partial3_tau=-(W_g_der(i,:)*E(i,:)*inv(sigma_nor)*E(i,:)' + W_g(i,:))*E(i,:)*inv(sigma_nor)*Z*dD_tau*Z'*inv(sigma_nor)*E(i,:)';
    Partial3_fi=-(W_g_der(i,:)*E(i,:)*inv(sigma_nor)*E(i,:)' + W_g(i,:))*E(i,:)*inv(sigma_nor)*dV_fi*inv(sigma_nor)*E(i,:)';
    Delta3_i=[Partial3_tau;Partial3_f;Partial3_fi];
    DELTA3(:,i)=Delta3_i;
end

