%&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
%Calculating Delta matrix for parameter tau
%&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&

%Case-weight perturbation

for i=1:n 
        Partial1_beta=-2*W_g(i,:)*XX(i,:)*inv(sigma_exp)*E(i,:)'; 
        Partial1_f=-2*W_g(i,:)*N*inv(sigma_exp)*E(i,:)'; 
        Partial1_tau=-(1/2)*trace(inv(sigma_exp)*Z*dD_tau*Z')-W_g(i,:)*E(i,:)*inv(sigma_exp)*Z*dD_tau*Z'*inv(sigma_exp)*E(i,:)';
        Partial1_fi=-(1/2)*trace(inv(sigma_exp)*dV_fi)-W_g(i,:)*E(i,:)*inv(sigma_exp)*dV_fi*inv(sigma_exp)*E(i,:)';
        Delta1_i=[Partial1_tau;Partial1_beta;Partial1_f;Partial1_fi];
        DELTA1(:,i)=Delta1_i;
end

%Explanatory variable perturbation

%for i=1:n
%    Partial2_beta= 4*W_g_der(i,:)*XX(i,:)*inv(sigma_exp)*E(i,:)'*E(i,:)*inv(sigma_exp)*Beta_exp + 2*W_g(i,:)*(XX(i,:)*Beta_exp - E(i,:))*inv(sigma_exp);
%    Partial2_f= N'*inv(sigma_exp)*(4*W_g_der(i,:)*E(i,:)'*E(i,:) + 2*W_g(i,:)*sigma_exp)*inv(sigma_exp)*Beta_exp; % revisado
%    Partial2_tau= 2*E(i,:)*inv(sigma_exp)*Z*dD_tau*Z'*inv(sigma_exp)*(W_g_der(i,:)*E(i,:)'*E(i,:) +  W_g(i,:)*inv(sigma_exp))*inv(sigma_exp)*Beta_exp;% revisado
%    Partial2_fi= 2*E(i,:)*inv(sigma_exp)*dV_fi*inv(sigma_exp)*(W_g_der(i,:)*E(i,:)'*E(i,:) +  W_g(i,:)*inv(sigma_exp))*inv(sigma_exp)*Beta_exp;% revisado
%    Delta2_i=[Partial2_tau;Partial2_beta;Partial2_f; Partial2_fi];
%    DE(:,:,i)=Delta2_i;
%end
%DELTA2=[DE(:,:,1),DE(:,:,2),DE(:,:,3),DE(:,:,4),DE(:,:,5),DE(:,:,6),DE(:,:,7),DE(:,:,8),DE(:,:,9),DE(:,:,10)...
%        DE(:,:,11),DE(:,:,12),DE(:,:,13),DE(:,:,14),DE(:,:,15),DE(:,:,16),DE(:,:,17),DE(:,:,18),DE(:,:,19),DE(:,:,20),...
%        DE(:,:,21),DE(:,:,22),DE(:,:,23),DE(:,:,24),DE(:,:,25),DE(:,:,26),DE(:,:,27),DE(:,:,28),DE(:,:,29)];

%Scale perturbation

for i=1:n
    Partial3_beta=-2*(W_g_der(i,:)*E(i,:)*inv(sigma_exp)*E(i,:)' + W_g(i,:))*XX(i,:)*inv(sigma_exp)*E(i,:)';
    Partial3_f=-2*(W_g_der(i,:)*E(i,:)*inv(sigma_exp)*E(i,:)' + W_g(i,:))*N'*inv(sigma_exp)*E(i,:)';
    Partial3_tau=-(W_g_der(i,:)*E(i,:)*inv(sigma_exp)*E(i,:)' + W_g(i,:))*E(i,:)*inv(sigma_exp)*Z*dD_tau*Z'*inv(sigma_exp)*E(i,:)';
    Partial3_fi=-(W_g_der(i,:)*E(i,:)*inv(sigma_exp)*E(i,:)' + W_g(i,:))*E(i,:)*inv(sigma_exp)*dV_fi*inv(sigma_exp)*E(i,:)';
    Delta3_i=[Partial3_tau;Partial3_beta;Partial3_f; Partial3_fi];
    DELTA3(:,i)=Delta3_i;
end