%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%Calculating modified distances

for i=1:n
    ZZ_N(i,1)=((dk_teta_1(i,1)/p)^(1/3)-(1-(2/(9*p))))/(2/(9*p))^(1/2);
    Per_Nor(i)=norminv((i-0.5)/n,0,1);
end

%figure(1)
%plot(Per_Nor,sort(ZZ_N),'o')

figure(3)
qqplot(ZZ_N)


figure(2)
plot(dk_teta_1,'.')
aux=(0:1:n+1);
corte=chi2inv(0.975,6); %cutoff point
line(aux,ones(n+2,1)*corte, 'Color','black','LineWidth',1)
title('Normal')
xlabel('Index')
ylabel('Mahalanobis distance')
gtext('6','FontName','Courier black','Fontsize',14)
gtext('7','FontName','Courier black','Fontsize',14)
gtext('11','FontName','Courier black','Fontsize',14)
gtext('17','FontName','Courier black','Fontsize',14)