%%% Parameter taufi, Influence Graphs%%%
I_teta_teta=[I_tautau  I_taufi  I_btau' I_ftau';
             I_taufi'  I_fifi   I_bfi   I_ffi' ;
             I_btau    I_bfi    I_bb    I_bf ;
             I_ftau    I_ffi    I_bf'   I_ff];

if I_teta_teta==I_teta_teta'
      
   disp('Matrix I_teta_teta is symmetric')
else 
   disp('Matrix I_teta_teta is not symmetric')
end

I_teta_teta=(I_teta_teta'+I_teta_teta)/2; %Making matrix symmetric
[df1 df2]=size(tau_nor); %%Calculating scale parameter dimension
par_total=p2+r+df1; %% Calculating total number of parameters
I_taufi=I_teta_teta(1:p2+df2,1:p2+df2);
B_taufi=[zeros(r+p2,r+p2),zeros(r+p2,p2+df2);zeros(p2+df2,r+p2),inv(I_taufi)];
aux=(0:1:n+1);

%Case-weight perturbation
B_1=DELTA1'*(inv(I_teta_teta)-B_taufi)*DELTA1;
B_1=(B_1'+B_1)/2;
VpropiosB_1=eig(B_1);			%eigen value
[eB1,fB1]=eig(B_1);	
posi=find(abs(VpropiosB_1)==max(abs(VpropiosB_1))); %max eigen value
lmax_B1pond=eB1(:,posi);			%max eigen vector
Ci_B1pond=2*abs(diag(B_1));

%Explanatory variable perturbation
B_2=DELTA2'*(inv(I_teta_teta)-B_taufi)*DELTA2;
B_2=(B_2'+B_2)/2;
VpropiosB_2=eig(B_2);			%eigen value
[eB2,fB2]=eig(B_2);	
posi=find(abs(VpropiosB_2)==max(abs(VpropiosB_2))); %max eigen value
lmax_B2pond=eB2(:,posi);			%max eigen vector
Ci_B2pond=2*abs(diag(B_2));

%Scale perturbation
B_3=DELTA3'*(inv(I_teta_teta)-B_taufi)*DELTA3;
B_3=(B_3'+B_3)/2;
VpropiosB_3=eig(B_3);			%eigen value
[eB3,fB3]=eig(B_3);	
posi=find(abs(VpropiosB_3)==max(abs(VpropiosB_3))); %max eigen value
lmax_B3escala=eB3(:,posi);			%max eigen vector
Ci_B3escala=2*abs(diag(B_3));

figure(11)
plot(Ci_B1pond,'.')
corteB1_pond=2*mean(Ci_B1pond);
line(aux,ones(n+2,1)*corteB1_pond)
title('Student-t')
xlabel('Index')
ylabel('C_i')
gtext('5','FontName','Courier black','Fontsize',12)
gtext('19','FontName','Courier black','Fontsize',12)
gtext('21','FontName','Courier black','Fontsize',12)
gtext('29','FontName','Courier black','Fontsize',12)


aux_a=(0:1:(n*m2)+1);
figure(22)
plot(Ci_B2pond,'.')
corteB2_pond=4*mean(Ci_B2pond);
line(aux_a,ones(n*m2+2,1)*corteB2_pond)
title('Student-t')
xlabel('Index')
ylabel('C_i')

figure(33)
plot(Ci_B3escala,'.')
corteB3_escala=2*mean(Ci_B3escala);
line(aux,ones(n+2,1)*corteB3_escala)
title('Student-t')
xlabel('Index')
ylabel('C_i')
gtext('7','FontName','Courier black','Fontsize',12)
gtext('19','FontName','Courier black','Fontsize',12)
gtext('21','FontName','Courier black','Fontsize',12)


figure(44)
plot(abs(lmax_B1pond),'.')
title('Student-t')
xlabel('Index')
ylabel('|lmax|') 

figure(55)
plot(abs(lmax_B2pond),'.')
title('Student-t')
xlabel('Index')
ylabel('|lmax|')

figure(66)
plot(abs(lmax_B3escala),'.')
title('Student-t')
xlabel('Index')
ylabel('|lmax|')  