  %%%%%%%%%% Matrix Sigma Estimation %%%%%%%%%%%
  %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%   

   norma_tau=100;epsilon_tau=10^-10;
   itertau=0;%maxiter=20;
   while norma_tau >= epsilon_tau 
    
    sigma_i=sigma_in;  
    tau_i=tau_in;   
       
    dsig_d11=Z2*Z2';
    dsig_dfi=eye(m2,m2);

    for i=1:n2
    U_d11(i,:)=-(1/2)*(trace(inv(sigma_i)*dsig_d11) - E_nor(i,:)*inv(sigma_i)*dsig_d11*inv(sigma_i)*E_nor(i,:)');
    U_dfi(i,:)=-(1/2)*(trace(inv(sigma_i)*dsig_dfi) - E_nor(i,:)*inv(sigma_i)*dsig_dfi*inv(sigma_i)*E_nor(i,:)');
    end
    UD11=sum(U_d11);
    UDfi=sum(U_dfi);

    UD=[UD11; UDfi];

    b_d11=trace(inv(sigma_i)*dsig_d11)*trace(inv(sigma_i)*dsig_d11);
    b_dfi=trace(inv(sigma_i)*dsig_dfi)*trace(inv(sigma_i)*dsig_dfi);
    b_d11_dfi=trace(inv(sigma_i)*dsig_d11)*trace(inv(sigma_i)*dsig_dfi);
   
    p=m2;
    f_g=p*(p+2)/4;
    

    for i=1:n2
    I_d11(i,:)=(b_d11/4)*((4*f_g)/(p*(p+2))-1)+((2*f_g)/(p*(p+2)))*trace(inv(sigma_i)*dsig_d11*inv(sigma_i)*dsig_d11);
    I_fi(i,:)=(b_dfi/4)*((4*f_g)/(p*(p+2))-1)+((2*f_g)/(p*(p+2)))*trace(inv(sigma_i)*dsig_dfi*inv(sigma_i)*dsig_dfi);
    I_d11_dfi(i,:)=(b_d11_dfi/4)*((4*f_g)/(p*(p+2))-1)+((2*f_g)/(p*(p+2)))*trace(inv(sigma_i)*dsig_d11*inv(sigma_i)*dsig_dfi);
    end

    ID11=sum(I_d11);
    IDfi=sum(I_fi);
    ID11fi=sum(I_d11_dfi);
    ID=[ID11 ID11fi; ID11fi' IDfi];

    tau_es=tau_i+inv(ID)*UD;
    sigma_es=Z2*tau_es(1,1)*Z2'+tau_es(2,1)*eye(m2,m2);
    
    for i=1:n2
        d_tau1_i(i,1)=(Y2(i,:)' - XX(i,:)'*Beta_es-N2*F_es)'*inv(sigma_es)*(Y2(i,:)' - XX(i,:)'*Beta_es-N2*F_es);  %% OJO EM Y
    end  
    
    dk_tau_1=d_tau1_i;
    g_dk_tau_1=((2*pi)^(-0.5*p))*exp(-0.5.*dk_tau_1);
    l_tau_1=-(n2/2)*log(det(sigma_es))+sum(log(g_dk_tau_1)) - 0.5*lambda*F_es'*K*F_es;
    norma_tau=abs((l_tau_o-l_tau_1)/(l_tau_1));
    l_tau_o=l_tau_1;
    
    tau_in=[tau_es(1,1) ; tau_es(2,1)];
    sigma_in=sigma_es;
    
    itertau=itertau+1;
    
end

