dD_tau=1;
dV_fi=eye(p,p);    
N=N2;
Z=Z2;
n=n2;
W_g=w_g_exp;
W_g_der=-0.5*nu*(nu-1)*d_teta_exp.^(nu-2);
E=E_exp;

               %% Fisher matrix with respect to beta
for i=1:n
   i_bb(i,:)= XX(i,:)*inv(sigma_exp)*(2*W_g(i,:)*sigma_exp + 4*W_g_der(i,:)*E(i,:)'*E(i,:))*inv(sigma_exp)*XX(i,:)';
end
I_bb=sum(i_bb);

I_ff=zeros(p,p); %% Fisher matrix with respect to f
for i=1:n
   i_ff= N'*inv(sigma_exp)*(2*W_g(i,:)*sigma_exp + 4*W_g_der(i,:)*E(i,:)'*E(i,:))*inv(sigma_exp)*N - (lambda/n)*K;
   I_ff=I_ff+i_ff;
end

for i=1:n  %% Fisher with respect to tau
    i_tautau(i,:)=(1/2)*trace(inv(sigma_exp)*Z*(dD_tau*Z'*inv(sigma_exp)*Z*dD_tau)*Z')+...
    E(i,:)*inv(sigma_exp)*Z*(W_g_der(i,:)*dD_tau*Z'*inv(sigma_exp)*E(i,:)'*E(i,:)*inv(sigma_exp)*Z*dD_tau +...
    W_g(i,:)*dD_tau*Z'*inv(sigma_exp)*Z*dD_tau + W_g(i,:)*dD_tau*Z'*inv(sigma_exp)*Z*dD_tau)*Z'*inv(sigma_exp)*E(i,:)';
end
I_tautau=sum(i_tautau);

for i=1:n  %% Fisher matrix with respect to tau
    i_fifi(i,:)=(1/2)*trace(inv(sigma_exp)*dV_fi*inv(sigma_exp)*dV_fi)+...
    E(i,:)*inv(sigma_exp)*(W_g_der(i,:)*dV_fi*inv(sigma_exp)*E(i,:)'*E(i,:)*inv(sigma_exp)*dV_fi +...
    W_g(i,:)*dV_fi*inv(sigma_exp)*dV_fi + W_g(i,:)*dV_fi*inv(sigma_exp)*dV_fi)*inv(sigma_exp)*E(i,:)';
end
I_fifi=sum(i_fifi);


I_bf=zeros(p2,r); %% Fisher matrix with respect to beta-f
for i=1:n
   i_bf= XX(i,:)*inv(sigma_exp)*(2*W_g(i,:)*sigma_exp + 4*W_g_der(i,:)*E(i,:)'*E(i,:))*inv(sigma_exp)*N;
   I_bf=I_bf+i_bf;
end

             %% Fisher matrix with respect to beta-tau
for i=1:n
   i_btau(i,:)=2*XX(i,:)*inv(sigma_exp)*(W_g_der(i,:)*E(i,:)'*E(i,:)+...
   W_g(i,:)*sigma_exp)*inv(sigma_exp)*Z*dD_tau*Z'*inv(sigma_exp)*E(i,:)';
end
I_btau=sum(i_btau);

            %% Fisher matrix with respect to beta-fi
for i=1:n
   i_bfi(i,:)=2*XX(i,:)*inv(sigma_exp)*(W_g_der(i,:)*E(i,:)'*E(i,:)+...
   W_g(i,:)*sigma_exp)*inv(sigma_exp)*dV_fi*inv(sigma_exp)*E(i,:)';
end
I_bfi=sum(i_bfi);


I_ftau=zeros(r,1); %% Fisher matrix with respect to f-tau
for i=1:n
   i_ftau=2*N*inv(sigma_exp)*(W_g_der(i,:)*E(i,:)'*E(i,:)+...
   W_g(i,:)*sigma_exp)*inv(sigma_exp)*Z*dD_tau*Z'*inv(sigma_exp)*E(i,:)';
   I_ftau=I_ftau+i_ftau;    
end

I_ffi=zeros(r,1); %% Fisher matrix with respect to f-fi
for i=1:n
   i_ffi=2*N*inv(sigma_exp)*(W_g_der(i,:)*E(i,:)'*E(i,:)+W_g(i,:)*sigma_exp)*inv(sigma_exp)*dV_fi*inv(sigma_exp)*E(i,:)';
   I_ffi=I_ffi+i_ffi;    
end
                   %% Fisher matrix with respect to tau-fi
for i=1:n
   i_taufi(i,:)=(1/2)*trace(inv(sigma_exp)*dV_fi*inv(sigma_exp)*Z*dD_tau*Z')+...
   E(i,:)*inv(sigma_exp)*(W_g_der(i,:)*dV_fi*inv(sigma_exp)*E(i,:)'*E(i,:)*inv(sigma_exp)*Z*dD_tau*Z' + ...
   W_g(i,:)*dV_fi*inv(sigma_exp)*Z*dD_tau*Z' + W_g(i,:)*Z*dD_tau*Z'*inv(sigma_exp)*dV_fi)*inv(sigma_exp)*E(i,:)';
end
I_taufi=sum(i_taufi);

I_teta_teta=[I_bb I_bf I_btau I_bfi ; I_bf' I_ff I_ftau I_ffi ; I_btau' I_ftau' I_tautau I_taufi ; I_bfi' I_ffi' I_taufi I_fifi];


Ve_teta=inv(-I_teta_teta);
Dp_teta_exp=sqrt(diag(Ve_teta)); %% sd. dev. calculated from the observed Fisher matrix
