%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%Calculating modified distances

for i=1:n
    ZZ_T(i,1)= ((1-2/(9*nu))*(delta_teta_1(i,1)/p)^(1/3)-(1-2/(9*p)))/ ((2/(9*nu))*(delta_teta_1(i,1)/p)^(2/3)+(2/(9*p)))^(1/2);
    Per_Nor(i)=norminv((i-0.5)/n,0,1);
end   

figure(21)
%plot(Per_Nor,sort(ZZ_T),'o')   

qqplot(ZZ_T)

dt_t=delta_teta_1/mi;

figure(22)
plot(dt_t,'o')
aux=(1:1:n);
corte=finv(0.975,mi,nu); % cutoff point
line(aux,ones(n,1)*corte, 'Color','red','LineWidth',1)
title('Student_t')
xlabel('Index')
ylabel('Distance')


figure(33)
plot(delta_teta_1,-2*w_g_o,'.')
aux=(0:1:n+1);
corte=mean(-2*w_g_o); % cutoff point
line(aux,ones(n+2,1)*corte, 'Color','black','LineWidth',1)
title('Student_t')
xlabel('Mahalanobis distance')
ylabel('Estimated weight')

gtext('6','FontName','Courier black','Fontsize',12)
gtext('7','FontName','Courier black','Fontsize',12)
gtext('11','FontName','Courier black','Fontsize',12)
gtext('17','FontName','Courier black','Fontsize',12)