%%%Parameter F, Influence Graphs %%%
I_teta_teta= [I_ff I_ftau I_ffi; I_ftau' I_tautau I_taufi ; I_ffi' I_taufi I_fifi];

if I_teta_teta==I_teta_teta'
      
   disp('Matrix I_teta_teta is symmetric')
else 
   disp('Matrix I_teta_teta is not symmetric')
end

I_teta_teta=(I_teta_teta'+I_teta_teta)/2; %Making matrix symmetric
[df1 df2]=size(tau_nor); %%Calculating scale parameter dimension 
par_total=r+df1; %%Calculating total number of parameters
I_beta=I_teta_teta(r+1:par_total,r+1:par_total);
B_beta=[zeros(r,r),zeros(r,df1);zeros(df1,r),inv(I_beta)];
aux=(0:1:n+1);

%Case-weight perturbation
B_1=DELTA1'*(inv(I_teta_teta)-B_beta)*DELTA1;
B_1=(B_1'+B_1)/2;
VpropiosB_1=eig(B_1);			%eigenvalue
[eB1,fB1]=eig(B_1);	
posi=find(abs(VpropiosB_1)==max(abs(VpropiosB_1))); %max eigenvalue
lmax_B1pond=eB1(:,posi);			%max eigenvector
Ci_B1pond=2*abs(diag(B_1));

%Scale perturbation
B_3=DELTA3'*(inv(I_teta_teta)-B_beta)*DELTA3;
B_3=(B_3'+B_3)/2;
VpropiosB_3=eig(B_3);			%eigenvalue
[eB3,fB3]=eig(B_3);	
posi=find(abs(VpropiosB_3)==max(abs(VpropiosB_3))); %max eigenvalue
lmax_B3escala=eB3(:,posi);			%max eigenvector
Ci_B3escala=2*abs(diag(B_3));

figure(1)
plot(Ci_B1pond,'o')
corteB1_pond=2*mean(Ci_B1pond);
line(aux,ones(n+2,1)*corteB1_pond)
title('Normal')
xlabel('Index')
ylabel('C_i')
gtext('6','FontName','Courier black','Fontsize',12)
gtext('7','FontName','Courier black','Fontsize',12)
gtext('11','FontName','Courier black','Fontsize',12)
gtext('17','FontName','Courier black','Fontsize',12)

figure(2)
plot(Ci_B3escala,'o')
corteB3_escala=2*mean(Ci_B3escala);
line(aux,ones(n+2,1)*corteB3_escala)
title('Normal')
xlabel('Index')
ylabel('C_i')
gtext('6','FontName','Courier black','Fontsize',12)
gtext('7','FontName','Courier black','Fontsize',12)
gtext('11','FontName','Courier black','Fontsize',12)
gtext('17','FontName','Courier black','Fontsize',12)

figure(3)
plot(abs(lmax_B1pond),'o')
title('Normal')
xlabel('Index')
ylabel('|lmax|')  

figure(4)
plot(abs(lmax_B3escala),'o')
title('Normal')
xlabel('Index')
ylabel('|lmax|')  

