%%%Parameter tau, Influence Graphs %%%
I_teta_teta=[I_tautau I_ftau' I_taufi' ; I_ftau I_ff  I_ffi ; I_taufi I_ffi' I_fifi];

%I_teta_teta=[I_tautau I_taufi I_ftau' ; I_taufi' I_fifi I_ffi' ; I_ftau I_ffi I_ff];

if I_teta_teta==I_teta_teta'
      
   disp('Matrix I_teta_teta is symmetric')
else 
   disp('Matrix I_teta_teta is not symmetric')
end

I_teta_teta=(I_teta_teta'+I_teta_teta)/2; %Making matrix symmetric
[df1 df2]=size(tau_nor); %%Calculating scale parameter dimension
par_total=r+df1; %% Calculating total number of parameters
I_beta=I_teta_teta(df1:par_total,df1:par_total);
B_beta=[zeros(1,1),zeros(1,r+1);zeros(r+1,1),inv(I_beta)];
aux=(0:1:n+1);

%Case-weight perturbation
B_1=DELTA1'*(inv(I_teta_teta)-B_beta)*DELTA1;
B_1=(B_1'+B_1)/2;
VpropiosB_1=eig(B_1);			%eigen value
[eB1,fB1]=eig(B_1);	
posi=find(abs(VpropiosB_1)==max(abs(VpropiosB_1))); %max eigen value
lmax_B1pond=eB1(:,posi);			%max eigen vector
Ci_B1pond=2*abs(diag(B_1));

% perturbacin de escala
B_3=DELTA3'*(inv(I_teta_teta)-B_beta)*DELTA3;
B_3=(B_3'+B_3)/2;
VpropiosB_3=eig(B_3);			%eigen value
[eB3,fB3]=eig(B_3);	
posi=find(abs(VpropiosB_3)==max(abs(VpropiosB_3))); %max eigen value
lmax_B3escala=eB3(:,posi);			%max eigen vector
Ci_B3escala=2*abs(diag(B_3));

figure(21)
plot(Ci_B1pond,'.')
corteB1_pond=2*mean(Ci_B1pond);
line(aux,ones(n+2,1)*corteB1_pond)
title('Student-t')
xlabel('Index')
ylabel('C_i')

figure(22)
plot(Ci_B3escala,'.')
corteB3_escala=2*mean(Ci_B3escala);
line(aux,ones(n+2,1)*corteB3_escala)
title('Student-t')
xlabel('Index')
ylabel('C_i')

figure(23)
plot(abs(lmax_B1pond),'.')
title('Student-t')
xlabel('Index')
ylabel('|lmax|')  

figure(24)
plot(abs(lmax_B3escala),'.')
title('Student-t')
xlabel('Index')
ylabel('|lmax|')         
                    
                    
     