dD_tau=1;
dV_fi=eye(p,p);    
%D_v=eye(n);
W_g=w_g_o;
W_g_der=(nu+mi)./(2*(nu+delta_tau_1).^2);

I_ff=zeros(p,p); %%Fisher matrix with respect to f
for i=1:n
   i_ff= N'*inv(sigma_tt)*(2*W_g(i,:)*sigma_n + 4*W_g_der(i,:)*E(i,:)'*E(i,:))*inv(sigma_n)*N - (lambda/n)*K;
   I_ff=I_ff+i_ff;
end
for i=1:n  %%Fisher matrix with respect to fi
    i_tautau(i,:)=(1/2)*trace((dD_tau*(Z'*inv(sigma_tt)*Z)*dD_tau)*(Z'*inv(sigma_tt)*Z))+...
                 (E(i,:)*inv(sigma_tt)*Z)*(W_g_der(i,:)*dD_tau*(Z'*inv(sigma_tt)*E(i,:)'*E(i,:)*inv(sigma_tt)*Z)*dD_tau+...
                  W_g(i,:)*dD_tau*(Z'*inv(sigma_tt)*Z)*dD_tau + W_g(i,:)*dD_tau*(Z'*inv(sigma_tt)*Z)*dD_tau)*(Z'*inv(sigma_tt)*E(i,:)');
end
I_tautau=sum(i_tautau);

for i=1:n  %%Fisher matrix with respect to tau
    i_fifi(i,:)=(1/2)*trace(inv(sigma_tt)*(dV_fi*inv(sigma_tt)*dV_fi))+...
                E(i,:)*inv(sigma_tt)*(W_g_der(i,:)*dV_fi*inv(sigma_tt)*E(i,:)'*E(i,:)*inv(sigma_tt)*dV_fi+...
                W_g(i,:)*dV_fi*inv(sigma_tt)*dV_fi + W_g(i,:)*dV_fi*inv(sigma_tt)*dV_fi)*inv(sigma_tt)*E(i,:)';
end
I_fifi=sum(i_fifi);

I_ftau=zeros(r,1); %%Fisher matrix with respect to f-tau
for i=1:n
   i_ftau=2*N*inv(sigma_tt)*(W_g_der(i,:)*E(i,:)'*E(i,:)+W_g(i,:)*sigma_tt)*inv(sigma_n)*Z*dD_tau*Z'*inv(sigma_tt)*E(i,:)';
   I_ftau=I_ftau+i_ftau;    
end

I_ffi=zeros(r,1); %%Fisher matrix with respect to f-fi
for i=1:n
   i_ffi=2*N*inv(sigma_tt)*(W_g_der(i,:)*E(i,:)'*E(i,:)+W_g(i,:)*sigma_tt)*inv(sigma_tt)*dV_fi*inv(sigma_tt)*E(i,:)';
   I_ffi=I_ffi+i_ffi;    
end


                    %%Fisher matrix with respect to tau-fi
for i=1:n
   i_taufi=(1/2)*trace(inv(sigma_tt)*dV_fi*inv(sigma_tt)*Z*dD_tau*Z')+...
            (E(i,:)*inv(sigma_tt))*(W_g_der(i,:)*dV_fi*inv(sigma_tt)*E(i,:)'*E(i,:)*inv(sigma_tt)*Z*dD_tau*Z'+...
            W_g(i,:)*dV_fi*inv(sigma_tt)*Z*dD_tau*Z' + W_g(i,:)*Z*dD_tau*Z'*inv(sigma_tt)*dV_fi)*(inv(sigma_tt)*E(i,:)');
end
I_taufi=sum(i_taufi);


%I_teta_teta= [I_ff I_ftau I_ffi; I_ftau' I_tautau I_taufi ; I_ffi' I_taufi I_fifi];

%Ve_teta=inv(-I_teta_teta);
%Dp_teta=sqrt(diag(Ve_teta)); %%std. dev. calculated form the observed Fisher information

