%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%Calculating modified distances

%for i=1:n2
 %   ZZ_T(i,1)= ((1-2/(9*nu))*(d_teta1_t(i,1)/p)^(1/3)-(1-2/(9*p)))/ ((2/(9*nu))*(d_teta1_t(i,1)/p)^(2/3)+(2/(9*p)))^(1/2);
  %  Per_Nor(i)=norminv((i-0.5)/n2,0,1);
%end   

%figure(21)
%plot(Per_Nor,sort(ZZ_T),'.')
%title('Student-t')
%xlabel('Quantiles of N(0,1)')
%ylabel('Transformed distance')

%figure(22)
%qqplot(ZZ_T)

dt_exp=d_teta_exp.^nu;

figure(32)
plot(dt_exp,'.')
aux=(0:1:n2+1);
corte=4*gaminv(0.975,(m2/(2*nu)),0.5); %cutoff point
line(aux,ones(n2+2,1)*corte, 'Color','red','LineWidth',1)
title('Power exponential')
xlabel('Index')
ylabel('Modified distance')

figure(33)
plot(d_teta_exp,v_exp,'.')
aux_b=(0:1:n2+1);
corte_b=1;
line(aux_b,ones(n2+2,1)*corte_b, 'Color','red','LineWidth',1)
title('Power exponential')
xlabel('Mahalanobis distance')
ylabel('Estimated weight')